# hamswap.tcl
# manage the KM/LL2 stuff

proc Manage {game} {
	if {$game == "km"} {
		wm title . "HamSwap for Kid Mystic"
		label .kmtx -text "HamSwap for Kid Mystic"
		button .km -text "Change First World" -command [list ChangeLevel km]
		button .kmbk -text "Restore Original Worlds" -command [list RestoreBackupsKM]
		pack .kmtx .km .kmbk -side top -fill x -padx 1 -pady 1
	} elseif {$game == "ll"} {
		wm title . "HamSwap for Loonyland"
		label .ltx -text "HamSwap for Loonyland"
		button .loony -text "Change Original Adventure" -command [list ChangeLevel ll loony]
		button .remix -text "Change Remix Adventure" -command [list ChangeLevel ll remix]
		button .boss -text "Change Boss Bash Sequence" -command [list ChangeLevel ll boss]
		button .ball -text "Change Loonyball Fields" -command [list ChangeLevel ll ball]
		button .survive -text "Change Survival Maps" -command [list ChangeLevel ll survive]
		button .bowl -text "Change Bowling Lane" -command [list ChangeLevel ll bowl]
		button .lbk -text "Restore Original Worlds" -command [list RestoreBackupsLL]
		pack .ltx .loony .remix .boss .ball .survive .bowl .lbk -side top -fill x -padx 1 -pady 1
	}
	label .stat -text "No action selected"
	button .quit -text "Quit HamSwap" -command exit
	pack .stat .quit -side top -fill x -padx 1 -pady 1
	focus .
}

proc ChangeLevel {game {game2 {}}} {
	.stat configure -text "Choosing addon..."
	set game3 $game2
	if {$game2 == "remix" || $game2 == "loony"} {
		set game2 adv
	}
	if {$game == "km"} {
		set types {{{Kid Mystic World} {.dlw}} {{All Files} {*}}}
		set def .dlw
	} elseif {$game == "ll"} {
		array set t {adv Adventure boss {Boss Bash} ball Loonyball survive Survival bowl Bowling}
		set types [list [list "Loonyland $t($game2) World" .$game2.llw] [list "Loonyland World" .llw] [list "All Files" *]]
		set def .$game2.llw
	} else {
		return
	}
	set name [tk_getOpenFile -filetypes $types -initialdir [pwd] -defaultext $def]
	if {$name == ""} {
		.stat configure -text "Loading Cancelled"
		return
	}
	if {$game == "km"} {
		set newfile "river.dlw"
	} elseif {$game == "ll"} {
		set newfile "$game3.llw"
	} else {
		return
	}
	file delete $newfile
	file copy -force $name $newfile
	
	.stat configure -text "Loading OK!"
}

proc RestoreBackupsKM {} {
	.stat configure -text "Please wait..."
	
	file copy -force river.backup.dlw river.dlw
	file copy -force forest.backup.dlw forest.dlw
	file copy -force castle.backup.dlw castle.dlw
	file copy -force under.backup.dlw under.dlw
	
	.stat configure -text "Restoration OK!"
}

proc RestoreBackupsLL {} {
	.stat configure -text "Please wait..."
	
	file copy -force original.adv.llw loony.llw
	file copy -force remix.adv.llw remix.llw
	file copy -force original.boss.llw boss.llw
	file copy -force original.ball.llw ball.llw
	file copy -force original.survive.llw survive.llw
	file copy -force original.bowl.llw bowl.llw
	
	.stat configure -text "Restoration OK!"
}

set game "??"

if {[llength $argv] > 0} {
	if {[lindex $argv 0] == "km"} {
		set game "km"
	} elseif {[lindex $argv 0] == "ll"} {
		set game "ll"
	}
} else {
	if {[file exists docs/energy_orb.gif]} {
		set game "km"
	}
	if {[file exists docs/instr_lightning.gif]} {
		if {$game == "??"} {
			set game "ll"
		} else {
			set game "??"
		}
	}
}

if {$game == "??"} {
	tk_messageBox -message "HamSwap can't detect whether you're running Kid Mystic or Loonyland!"
	exit
}

if {$game == "km"} {
	if {![file exists river.backup.dlw]} {
		file copy -force river.dlw river.backup.dlw
		file copy -force forest.dlw forest.backup.dlw
		file copy -force castle.dlw castle.backup.dlw
		file copy -force under.dlw under.backup.dlw
	}
} elseif {$game == "ll"} {
	if {![file exists original.adv.llw]} {
		file copy -force loony.llw original.adv.llw
		file copy -force remix.llw remix.adv.llw
		file copy -force boss.llw original.boss.llw
		file copy -force ball.llw original.ball.llw
		file copy -force survive.llw original.survive.llw
		file copy -force bowl.llw original.bowl.llw
	}
}

Manage $game








# this is filler space to make editing easier
# so much easier





